<div id="firstpage">
    <img src="./img/screenshot.png" alt="screenshot" />
</div>


À propos de ce manuel
---------------------

Ce manuel est à destination des personnes qui souhaitent comprendre le 
fonctionnement des intelligences artificielles implémentées par nos 
soins en JavaScript.


Présentations des IA
--------------------

Nous avons procédé à plusieurs test des IA afin de les comparer et de 
déterminer les meilleurs algorithmes.

<table class="chart chart-bar color"><tr><th colspan="2">IAs win ratio</th></tr><tr class="data"><td>Dummy IA (0%)</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>Simple IA (0%)</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>Carsso IA (0%)</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>Morsi IA (0%)</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>Morsi2 IA (0%)</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>FLOZz IA (26%)</td><td><div class="chart-bar-bar" style="width: 26%;"></div></td></tr><tr class="data"><td>FLOZz² IA (21%)</td><td><div class="chart-bar-bar" style="width: 21%;"></div></td></tr></table>
<table class="chart chart-bar color"><tr><th colspan="2">Best Tile</th></tr><tr class="data"><td>Dummy IA (512)</td><td><div class="chart-bar-bar" style="width: 25%;"></div></td></tr><tr class="data"><td>Simple IA (512)</td><td><div class="chart-bar-bar" style="width: 25%;"></div></td></tr><tr class="data"><td>Carsso IA (1024)</td><td><div class="chart-bar-bar" style="width: 50%;"></div></td></tr><tr class="data"><td>Morsi IA (512)</td><td><div class="chart-bar-bar" style="width: 25%;"></div></td></tr><tr class="data"><td>Morsi2 IA (1024)</td><td><div class="chart-bar-bar" style="width: 50%;"></div></td></tr><tr class="data"><td>FLOZz IA (2048)</td><td><div class="chart-bar-bar" style="width: 100%;"></div></td></tr><tr class="data"><td>FLOZz² IA (2048)</td><td><div class="chart-bar-bar" style="width: 100%;"></div></td></tr></table>
<div style="page-break-after: always"></div>


### Dummy IA

« Dummy IA » se contente de tourner en rond (haut, droite, bas, gauche)

**En résumé :**

* Tuile maximale attente: 512 (très rare)
* Tuile fréquemment attente: 128
* Perd entre 100 et 200 coups en moyenne
* Ne gagne jamais

<table class="chart chart-bar slim"><tr><th colspan="2">Moves (win)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<table class="chart chart-bar slim"><tr><th colspan="2">Moves (loose)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 7%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 70%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 21%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 2%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<div style="page-break-after: always"></div>


### Simple IA

Cette IA réunit à chaque tour le maximum de tuiles ayant les valeurs
les plus élevés. Dans le cas où deux mouvements sont équivalents, elle 
choisit celui qui génère le plus de mouvements.

**En résumé :**

* Tuile maximale attente: 512
* Tuile fréquemment attente: 256
* Perd entre 100 et 300 coups en moyenne
* Ne gagne jamais

<table class="chart chart-bar slim"><tr><th colspan="2">Moves (win)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<table class="chart chart-bar slim"><tr><th colspan="2">Moves (loose)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 28%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 49%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 19%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 4%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<div style="page-break-after: always"></div>


### Carsso IA

Amélioration de « Simple IA » visant à prévoir deux coups à l'avance.

**En résumé :**

* Tuile maximale attente: 1024 
* Tuile fréquemment attente: 512
* Perd entre 200 et 500 coups en moyenne
* Ne gagne jamais

<table class="chart chart-bar slim"><tr><th colspan="2">Moves (win)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<table class="chart chart-bar slim"><tr><th colspan="2">Moves (loose)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 7%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 30%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 37%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 19%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 3%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 2%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 2%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<div style="page-break-after: always"></div>


### Morsi IA

Tentative de solveur utilisant un système de phase de jeu. Le but étant
de faire comprendre à l'IA quand réunir des tuiles et quand les 
« stocker ». 

**En résumé :**

* Tuile maximale attente: 512 
* Tuile fréquemment attente: 512
* Perd entre 100 et 300 coups en moyenne
* Ne gagne jamais

<table class="chart chart-bar slim"><tr><th colspan="2">Moves (win)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<table class="chart chart-bar slim"><tr><th colspan="2">Moves (loose)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 1%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 32%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 49%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 16%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 2%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<div style="page-break-after: always"></div>


### Morsi2 IA

Ce solveur de 2048 part du postulat qu'il est plus difficile de perdre 
quand un ligne de la grille est complète. Par exemple, en prenant soin
de toujours remplir la ligne supérieur on peut aisément bouger de droite
à gauche tout en conservant les « grosses » tuiles dans un angle. 

**En résumé :**

* Tuile maximale attente: 1024 
* Tuile fréquemment attente: 512
* Perd entre 300 et 700 coups en moyenne
* Ne gagne jamais

<table class="chart chart-bar slim"><tr><th colspan="2">Moves (win)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<table class="chart chart-bar slim"><tr><th colspan="2">Moves (loose)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 9%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 12%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 26%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 22%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 13%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 6%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 8%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 3%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 1%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<div style="page-break-after: always"></div>


### FLOZz IA

Cette IA tente de placer la tuile ayant la valeur la plus élevé dans un
angle et essaye de rapprocher des tuiles ayant des valeurs proche tout 
en essayant de libérer un maximum de cases. 


**En résumé :**

* Tuile maximale attente: 2048 
* Tuile fréquemment attente: 1024
* Perd entre 700 et 900 coups en moyenne
* Gagne 20% à 30% des parties en environ 800-900 coups

<table class="chart chart-bar slim"><tr><th colspan="2">Moves (win)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 88%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 12%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<table class="chart chart-bar slim"><tr><th colspan="2">Moves (loose)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 1%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 8%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 16%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 9%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 12%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 22%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 24%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 5%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 1%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<div style="page-break-after: always"></div>


### FLOZz² IA

« FLOZz² IA » est une tentative d'amélioration de « FLOZz IA » qui
tente de classer les tuiles dans un ordre décroissant depuis le 
positionnement de la tuile dîtes « forte ».

**En résumé :**

* Tuile maximale attente: 2048 
* Tuile fréquemment attente: 1024
* Perd entre 600 et 900 coups en moyenne
* Gagne 20% à 30% des parties en environ 800-1000 coups

<table class="chart chart-bar slim"><tr><th colspan="2">Moves (win)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 62%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 29%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 5%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 5%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>
<table class="chart chart-bar slim"><tr><th colspan="2">Moves (loose)</th></tr><tr class="data"><td>0-99</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>100-199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>200-299</td><td><div class="chart-bar-bar" style="width: 1%;"></div></td></tr><tr class="data"><td>300-399</td><td><div class="chart-bar-bar" style="width: 6%;"></div></td></tr><tr class="data"><td>400-499</td><td><div class="chart-bar-bar" style="width: 14%;"></div></td></tr><tr class="data"><td>500-599</td><td><div class="chart-bar-bar" style="width: 3%;"></div></td></tr><tr class="data"><td>600-699</td><td><div class="chart-bar-bar" style="width: 18%;"></div></td></tr><tr class="data"><td>700-799</td><td><div class="chart-bar-bar" style="width: 23%;"></div></td></tr><tr class="data"><td>800-899</td><td><div class="chart-bar-bar" style="width: 29%;"></div></td></tr><tr class="data"><td>900-999</td><td><div class="chart-bar-bar" style="width: 5%;"></div></td></tr><tr class="data"><td>1000-1099</td><td><div class="chart-bar-bar" style="width: 1%;"></div></td></tr><tr class="data"><td>1100-1199</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1200-1299</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1300-1399</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr><tr class="data"><td>1400-1499</td><td><div class="chart-bar-bar" style="width: 0%;"></div></td></tr></table>


Pourquoi JavaScript ?
---------------------

JavaScript est un langage bien connu de tout les membres du projet. Il
était donc simple et rapide de développer dans ce langage. Il est en
plus portable, il suffit d'avoir un navigateur récent. (Firefox ou chrome de préférence) 

