var SimpleIA = BaseIA.$extend({

    _name: "Simple IA",

    play: function() {
        this.$super();

        this.loop(function() {
            var result = [];

            for (var i = 0; i < this.MOVES.length; i++) {
                var s = this.simulate(this.MOVES[i].dx, this.MOVES[i].dy);
                if (s.moves > 0) {
                    result.push({
                        name: this.MOVES[i].name,
                        moves: s.moves,
                        points: s.points
                    });
                }
            }

            result.sort(function(a, b) {
                if (a.points == b.points) {
                    if (a.moves == b.moves) return 0;
                    else if (a.moves < b.moves) return -1;
                    else return 1;
                }
                else {
                    if (a.points < b.points) return -1;
                    else return 1;
                }
            });

            game[result[result.length - 1].name]();
        }.bind(this));
    }

});

new SimpleIA();
